include "$int.p"

function
  int pow(int, int)


(* primitive recursion ... is conservative extension *)
rule pow_def
  find pow(%a, %b)
  replace cond(%b > 0, %a * pow(%a, %b-1), 1)

rule pow0
  find pow(%a, 0)
  replace 1
  tags
    rewrite "fol simp"
    derived

rule pow_plus1
  assume %b >= 0 |-
  find pow(%a, %b + 1)
  replace %a * pow(%a, %b)
  tags
    rewrite "fol simp"
    derived

rule pow_add
  assume %b >= 0 |-
  assume %c >= 0 |-
  find pow(%a, %b+%c)
  replace pow(%a, %b) * pow(%a, %c)
  tags derived

rule pow_mul
  assume %b >= 0 |-
  find pow(%a*%a, %b)
  replace pow(%a, %b) * pow(%a, %b)
  tags derived

rule lemma_div1
  find (%y+1)/2
  replace cond($mod(%y,2) = 0, %y/2, %y/2+1)
  tags
   #rewrite "fol simp"
   derived

rule lemma_half
  find %b
  replace %b/2 + (%b+1)/2
  tags
   rewrite "fol simp"
   derived


rule lemma_pow1
   assume %b >= 0 |-
   find pow(%a, %b)
   replace pow(%a * %a, %b/2) * cond($mod(%b, 2) = 0, 1, %a)
   tags
     derived
