/*
 * This file is part of
 *    ivil - Interactive Verification on Intermediate Language
 *
 * Copyright (C) 2009-2012 Karlsruhe Institute of Technology
 *
 * The system is protected by the GNU General Public License.
 * See LICENSE.TXT (distributed with this file) for details.
 */
package de.uka.iti.pseudo.parser.boogie;


/**
 * Token literal values and constants.
 * Generated by org.javacc.parser.OtherFilesGen#start()
 */
public interface BPLParserConstants {

  /** End of File. */
  int EOF = 0;
  /** RegularExpression Id. */
  int LETTER = 1;
  /** RegularExpression Id. */
  int DIGIT = 2;
  /** RegularExpression Id. */
  int SPECIAL = 3;
  /** RegularExpression Id. */
  int GLYPH = 4;
  /** RegularExpression Id. */
  int NONDIGIT = 5;
  /** RegularExpression Id. */
  int SINGLE_LINE_COMMENT = 10;
  /** RegularExpression Id. */
  int VAR = 15;
  /** RegularExpression Id. */
  int WHERE = 16;
  /** RegularExpression Id. */
  int INT = 17;
  /** RegularExpression Id. */
  int BOOL = 18;
  /** RegularExpression Id. */
  int BVTYPE = 19;
  /** RegularExpression Id. */
  int CONST = 20;
  /** RegularExpression Id. */
  int UNIQUE = 21;
  /** RegularExpression Id. */
  int EXTENDS = 22;
  /** RegularExpression Id. */
  int COMPLETE = 23;
  /** RegularExpression Id. */
  int FUNCTION = 24;
  /** RegularExpression Id. */
  int RETURNS = 25;
  /** RegularExpression Id. */
  int AXIOM = 26;
  /** RegularExpression Id. */
  int TYPE = 27;
  /** RegularExpression Id. */
  int PROCEDURE = 28;
  /** RegularExpression Id. */
  int IMPLEMENTATION = 29;
  /** RegularExpression Id. */
  int MODIFIES = 30;
  /** RegularExpression Id. */
  int FREE = 31;
  /** RegularExpression Id. */
  int REQUIRES = 32;
  /** RegularExpression Id. */
  int ENSURES = 33;
  /** RegularExpression Id. */
  int GOTO = 34;
  /** RegularExpression Id. */
  int RETURN = 35;
  /** RegularExpression Id. */
  int IF = 36;
  /** RegularExpression Id. */
  int THEN = 37;
  /** RegularExpression Id. */
  int ELSE = 38;
  /** RegularExpression Id. */
  int WHILE = 39;
  /** RegularExpression Id. */
  int INVARIANT = 40;
  /** RegularExpression Id. */
  int BREAK = 41;
  /** RegularExpression Id. */
  int ASSERT = 42;
  /** RegularExpression Id. */
  int ASSUME = 43;
  /** RegularExpression Id. */
  int HAVOC = 44;
  /** RegularExpression Id. */
  int CALL = 45;
  /** RegularExpression Id. */
  int FALSE = 46;
  /** RegularExpression Id. */
  int TRUE = 47;
  /** RegularExpression Id. */
  int OLD = 48;
  /** RegularExpression Id. */
  int OP_ASSIGN = 49;
  /** RegularExpression Id. */
  int OP_EQUIV = 50;
  /** RegularExpression Id. */
  int OP_IMPL = 51;
  /** RegularExpression Id. */
  int OP_EXPL = 52;
  /** RegularExpression Id. */
  int OP_AND = 53;
  /** RegularExpression Id. */
  int OP_OR = 54;
  /** RegularExpression Id. */
  int OP_NEGATION = 55;
  /** RegularExpression Id. */
  int OP_NEQ = 56;
  /** RegularExpression Id. */
  int OP_LTE = 57;
  /** RegularExpression Id. */
  int OP_GTE = 58;
  /** RegularExpression Id. */
  int OP_MUL = 59;
  /** RegularExpression Id. */
  int OP_FORALL = 60;
  /** RegularExpression Id. */
  int OP_EXISTS = 61;
  /** RegularExpression Id. */
  int OP_LAMBDA = 62;
  /** RegularExpression Id. */
  int OP_SEP = 63;
  /** RegularExpression Id. */
  int SEP_RCURLY = 64;
  /** RegularExpression Id. */
  int SEP_LCURLY = 65;
  /** RegularExpression Id. */
  int SEP_RBRACKET = 66;
  /** RegularExpression Id. */
  int SEP_LBRACKET = 67;
  /** RegularExpression Id. */
  int IDENT = 68;
  /** RegularExpression Id. */
  int BVLIT = 69;
  /** RegularExpression Id. */
  int STRING = 70;
  /** RegularExpression Id. */
  int FLOAT = 71;
  /** RegularExpression Id. */
  int INTEGER = 72;

  /** Lexical state. */
  int DEFAULT = 0;
  /** Lexical state. */
  int COMMENT = 1;

  /** Literal token values. */
  String[] tokenImage = {
    "<EOF>",
    "<LETTER>",
    "<DIGIT>",
    "<SPECIAL>",
    "<GLYPH>",
    "<NONDIGIT>",
    "\" \"",
    "\"\\t\"",
    "\"\\n\"",
    "\"\\r\"",
    "<SINGLE_LINE_COMMENT>",
    "\"/*\"",
    "\"/*\"",
    "\"*/\"",
    "<token of kind 14>",
    "\"var\"",
    "\"where\"",
    "\"int\"",
    "\"bool\"",
    "<BVTYPE>",
    "\"const\"",
    "\"unique\"",
    "\"extends\"",
    "\"complete\"",
    "\"function\"",
    "\"returns\"",
    "\"axiom\"",
    "\"type\"",
    "\"procedure\"",
    "\"implementation\"",
    "\"modifies\"",
    "\"free\"",
    "\"requires\"",
    "\"ensures\"",
    "\"goto\"",
    "\"return\"",
    "\"if\"",
    "\"then\"",
    "\"else\"",
    "\"while\"",
    "\"invariant\"",
    "\"break\"",
    "\"assert\"",
    "\"assume\"",
    "\"havoc\"",
    "\"call\"",
    "\"false\"",
    "\"true\"",
    "\"old\"",
    "\":=\"",
    "<OP_EQUIV>",
    "<OP_IMPL>",
    "<OP_EXPL>",
    "<OP_AND>",
    "<OP_OR>",
    "<OP_NEGATION>",
    "<OP_NEQ>",
    "<OP_LTE>",
    "<OP_GTE>",
    "\"*\"",
    "<OP_FORALL>",
    "<OP_EXISTS>",
    "<OP_LAMBDA>",
    "<OP_SEP>",
    "\"}\"",
    "\"{\"",
    "\"]\"",
    "\"[\"",
    "<IDENT>",
    "<BVLIT>",
    "<STRING>",
    "<FLOAT>",
    "<INTEGER>",
    "\";\"",
    "\"(\"",
    "\")\"",
    "\":\"",
    "\",\"",
    "\"<\"",
    "\">\"",
    "\"=\"",
    "\"==\"",
    "\"<:\"",
    "\"++\"",
    "\"+\"",
    "\"-\"",
    "\"/\"",
    "\"%\"",
    "\"|{\"",
    "\"}|\"",
  };

}
