/* Generated By:JavaCC: Do not edit this line. Parser.java */
package de.uka.iti.pseudo.parser;

import de.uka.iti.pseudo.parser.file.*;
import de.uka.iti.pseudo.parser.term.*;
import de.uka.iti.pseudo.parser.program.*;
import de.uka.iti.pseudo.term.Modality;
import de.uka.iti.pseudo.util.Pair;

import java.util.*;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.Reader;
import java.io.StringReader;
import java.net.URL;

@SuppressWarnings("all")
public class Parser implements ParserConstants {

    public Parser() {
       this(new StringReader(""));
    }

    public ASTFile parseFile(File file) throws FileNotFoundException, ParseException {
       return parseFile(new FileReader(file), file.getPath());
    }

    public ASTFile parseURL(URL url) throws ParseException, IOException {
        Reader reader = new InputStreamReader(url.openStream());
        return parseFile(reader, url.toString());
     }

    public ASTFile parseFile(Reader reader, String filename) throws ParseException {
        ReInit(reader);
        ASTFile result = File();
        result.setFilename(filename);
        return result;
    }

    public ASTTerm parseTerm(Reader reader, String filename) throws ParseException
    {
        ReInit(reader);
        ASTTerm term = TermEOF();
        term.setFilename(filename);
        return term;
    }


    public List<ASTStatement> parseProgram(Reader reader, String filename) throws ParseException
    {
        ReInit(reader);
        List<ASTStatement> statementList = StatementList();
        for(ASTStatement ast : statementList) {
            ast.setFilename(filename);
        }
        return statementList;
    }

    private void generateParserException(int[] expectedSequence) throws ParseException
    {
        int expected[][] = { expectedSequence };
        throw new ParseException(token, expected, tokenImage);
    }

    public static void main(String args[]) throws Exception {
        Parser p = new Parser();
        p.parseFile(new File(args[0]));
    }

//
// This file contains the grammar for files with sorts/functions/rules/program and problem definitions
// structural elements that have nothing to do with Terms
//
  final public ASTFile File() throws ParseException {
  ASTDeclarationBlock block;
  List<ASTDeclarationBlock> blocks = new ArrayList<ASTDeclarationBlock>();
  ASTProblemSequent problem = null;
    label_1:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case AXIOM:
      case BINDER:
      case FUNCTION:
      case INCLUDE:
      case PLUGIN:
      case PROGRAM:
      case PROPERTIES:
      case RULE:
      case SORT:
        ;
        break;
      default:
        jj_la1[0] = jj_gen;
        break label_1;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INCLUDE:
        block = IncludeDeclarationBlock();
        break;
      case PLUGIN:
        block = PluginsBlock();
        break;
      case PROPERTIES:
        block = PropertiesBlock();
        break;
      case SORT:
        block = SortDeclarationBlock();
        break;
      case FUNCTION:
        block = FunctionDeclarationBlock();
        break;
      case BINDER:
        block = BinderDeclarationBlock();
        break;
      case RULE:
        block = RuleDeclaration();
        break;
      case AXIOM:
        block = AxiomDeclaration();
        break;
      case PROGRAM:
        block = ProgramDeclaration();
        break;
      default:
        jj_la1[1] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
              blocks.add(block);
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case PROBLEM:
      problem = Problem();
      break;
    default:
      jj_la1[2] = jj_gen;
      ;
    }
    jj_consume_token(0);
     {if (true) return new ASTFile(blocks, problem);}
    throw new Error("Missing return statement in function");
  }

  final public ASTProblemSequent Problem() throws ParseException {
  List<ASTTerm> antecedent = new ArrayList<ASTTerm>();
  List<ASTTerm> succedent = new ArrayList<ASTTerm>();
  boolean hasSeqSep = false;
  ASTTerm t;
    jj_consume_token(PROBLEM);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LEFTPAREN:
    case LEFTCURLY:
    case LEFTDSQUARE:
    case OP_IDENTIFIER:
    case IDENTIFIER:
      t = Term();
                    antecedent.add(t);
      label_2:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[3] = jj_gen;
          break label_2;
        }
        jj_consume_token(COMMA);
        t = Term();
                          antecedent.add(t);
      }
      break;
    default:
      jj_la1[4] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SEP:
      jj_consume_token(SEP);
                hasSeqSep=true;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LEFTPAREN:
      case LEFTCURLY:
      case LEFTDSQUARE:
      case OP_IDENTIFIER:
      case IDENTIFIER:
        t = Term();
                      succedent.add(t);
        label_3:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[5] = jj_gen;
            break label_3;
          }
          jj_consume_token(COMMA);
          t = Term();
                            succedent.add(t);
        }
        break;
      default:
        jj_la1[6] = jj_gen;
        ;
      }
      break;
    default:
      jj_la1[7] = jj_gen;
      ;
    }
      if(antecedent.size() + succedent.size() == 0) {
         {if (true) throw new ParseException();}
      }
      if(!hasSeqSep && antecedent.size() > 1) {
         {if (true) throw new ParseException();}
      }
      if(!hasSeqSep) {
         // if only a single term, take that as *suc*cendent.
         {if (true) return new ASTProblemSequent(Collections.<ASTTerm>emptyList(), antecedent);}
      } else {
         {if (true) return new ASTProblemSequent(antecedent, succedent);}
      }
    throw new Error("Missing return statement in function");
  }

  final public ASTPlugins PluginsBlock() throws ParseException {
  Token first, service, implementation;
  List<ASTPluginDeclaration> pairs = new ArrayList<ASTPluginDeclaration>();
    first = jj_consume_token(PLUGIN);
    label_4:
    while (true) {
      service = jj_consume_token(IDENTIFIER);
      jj_consume_token(COLON);
      implementation = jj_consume_token(STRING);
               pairs.add(new ASTPluginDeclaration(service, implementation));
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IDENTIFIER:
        ;
        break;
      default:
        jj_la1[8] = jj_gen;
        break label_4;
      }
    }
      {if (true) return new ASTPlugins(first, pairs);}
    throw new Error("Missing return statement in function");
  }

  final public ASTProperties PropertiesBlock() throws ParseException {
  Token first, t, value, separator=null;
  StringBuilder name = new StringBuilder();
  List<ASTPropertiesDeclaration> pairs = new ArrayList<ASTPropertiesDeclaration>();
    first = jj_consume_token(PROPERTIES);
    label_5:
    while (true) {
      t = jj_consume_token(IDENTIFIER);
                           name.append(t.image);
      label_6:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case DOT:
          ;
          break;
        default:
          jj_la1[9] = jj_gen;
          break label_6;
        }
        jj_consume_token(DOT);
        t = jj_consume_token(IDENTIFIER);
                    name.append(".").append(t.image);
      }
      value = jj_consume_token(STRING);
                pairs.add(new ASTPropertiesDeclaration(name.toString(),value));
                name.setLength(0);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IDENTIFIER:
        ;
        break;
      default:
        jj_la1[10] = jj_gen;
        break label_5;
      }
    }
      {if (true) return new ASTProperties(first, pairs);}
    throw new Error("Missing return statement in function");
  }

  final public ASTIncludeDeclarationBlock IncludeDeclarationBlock() throws ParseException {
  Token first;
  Token string;
  List<Token> list = new ArrayList<Token>();
    first = jj_consume_token(INCLUDE);
    label_7:
    while (true) {
      string = jj_consume_token(STRING);
                                            list.add(string);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STRING:
        ;
        break;
      default:
        jj_la1[11] = jj_gen;
        break label_7;
      }
    }
            {if (true) return new ASTIncludeDeclarationBlock(first, list);}
    throw new Error("Missing return statement in function");
  }

  final public ASTSortDeclarationBlock SortDeclarationBlock() throws ParseException {
  Token first;
  ASTSortDeclaration sd;
  List<ASTSortDeclaration> list = new ArrayList<ASTSortDeclaration>();
    first = jj_consume_token(SORT);
    label_8:
    while (true) {
      sd = SortDeclaration();
                                              list.add(sd);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IDENTIFIER:
        ;
        break;
      default:
        jj_la1[12] = jj_gen;
        break label_8;
      }
    }
           {if (true) return new ASTSortDeclarationBlock(first, list);}
    throw new Error("Missing return statement in function");
  }

  final public ASTSortDeclaration SortDeclaration() throws ParseException {
  Token name,  ty;
  List<Token> tyvars = new ArrayList<Token>();
  ASTMapType alias = null;
    name = jj_consume_token(IDENTIFIER);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LEFTPAREN:
      jj_consume_token(LEFTPAREN);
      ty = jj_consume_token(TYVAR_IDENTIFIER);
                                tyvars.add(ty);
      label_9:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[13] = jj_gen;
          break label_9;
        }
        jj_consume_token(COMMA);
        ty = jj_consume_token(TYVAR_IDENTIFIER);
                                     tyvars.add(ty);
      }
      jj_consume_token(RIGHTPAREN);
      break;
    default:
      jj_la1[14] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case AS:
      jj_consume_token(AS);
      alias = MapTypeRef();
      break;
    default:
      jj_la1[15] = jj_gen;
      ;
    }
      {if (true) return new ASTSortDeclaration(name, tyvars, alias);}
    throw new Error("Missing return statement in function");
  }

/**
 * @note: map type ref can only occur in sort declarations
 *
 * may types look a lot like boogie maps, but the polymorphic bound use
 * {} instead of < > to avoid the collision with the set of operators.
 * This works, because {} is used in updates(term) and parallel assignments(statement) and thus can not
 * be confused with types. [] is used by modal operators(term) and therefore can also not be confused with types.
 * Also does the addition of this rule not create any new warnings.
 */
  final public ASTMapType MapTypeRef() throws ParseException {
  Token location;
  List<ASTTypeVar> boundvars = new ArrayList<ASTTypeVar>();
  List<ASTType> domain = new ArrayList<ASTType>();
  ASTType range, tmp;
  ASTTypeVar schema;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LEFTCURLY:
      jj_consume_token(LEFTCURLY);
      schema = TypeVariable();
                                boundvars.add(schema);
      label_10:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[16] = jj_gen;
          break label_10;
        }
        jj_consume_token(COMMA);
        schema = TypeVariable();
                                  boundvars.add(schema);
      }
      jj_consume_token(RIGHTCURLY);
      break;
    default:
      jj_la1[17] = jj_gen;
      ;
    }
    location = jj_consume_token(LEFTSQUARE);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TYVAR_IDENTIFIER:
    case SCHEMA_TYPE_IDENTIFIER:
    case IDENTIFIER:
      tmp = TypeRef();
                      domain.add(tmp);
      label_11:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[18] = jj_gen;
          break label_11;
        }
        jj_consume_token(COMMA);
        tmp = TypeRef();
                        domain.add(tmp);
      }
      break;
    default:
      jj_la1[19] = jj_gen;
      ;
    }
    jj_consume_token(RIGHTSQUARE);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TYVAR_IDENTIFIER:
    case SCHEMA_TYPE_IDENTIFIER:
    case IDENTIFIER:
      range = TypeRef();
      break;
    case LEFTSQUARE:
    case LEFTCURLY:
      range = MapTypeRef();
      break;
    default:
      jj_la1[20] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    {if (true) return new ASTMapType(location, boundvars, domain, range);}
    throw new Error("Missing return statement in function");
  }

  final public ASTTypeVar TypeVariable() throws ParseException {
  Token token;
    token = jj_consume_token(TYVAR_IDENTIFIER);
        {if (true) return new ASTTypeVar(token);}
    throw new Error("Missing return statement in function");
  }

  final public ASTFunctionDeclarationBlock FunctionDeclarationBlock() throws ParseException {
  Token first;
  ASTFunctionDeclaration fd;
  List<ASTFunctionDeclaration> list = new ArrayList<ASTFunctionDeclaration>();
    first = jj_consume_token(FUNCTION);
    label_12:
    while (true) {
      fd = FunctionDeclaration();
                                                        list.add(fd);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case TYVAR_IDENTIFIER:
      case SCHEMA_TYPE_IDENTIFIER:
      case IDENTIFIER:
        ;
        break;
      default:
        jj_la1[21] = jj_gen;
        break label_12;
      }
    }
             {if (true) return new ASTFunctionDeclarationBlock(first, list);}
    throw new Error("Missing return statement in function");
  }

  final public ASTFunctionDeclaration FunctionDeclaration() throws ParseException {
  Token name, as = null, precedence = null;
  int modifier = 0;
  ASTType range, ty;
  List<ASTType> tyrefs = new ArrayList<ASTType>();
    range = TypeRef();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IDENTIFIER:
      name = jj_consume_token(IDENTIFIER);
      break;
    case INTERNAL_IDENTIFIER:
      name = jj_consume_token(INTERNAL_IDENTIFIER);
      break;
    default:
      jj_la1[22] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LEFTPAREN:
      jj_consume_token(LEFTPAREN);
      ty = TypeRef();
                             tyrefs.add(ty);
      label_13:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[23] = jj_gen;
          break label_13;
        }
        jj_consume_token(COMMA);
        ty = TypeRef();
                                  tyrefs.add(ty);
      }
      jj_consume_token(RIGHTPAREN);
      break;
    default:
      jj_la1[24] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ASSIGNABLE:
    case UNIQUE:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ASSIGNABLE:
        jj_consume_token(ASSIGNABLE);
                         modifier |= ASTFunctionDeclaration.MODIFIER_ASSIGNABLE;
        break;
      case UNIQUE:
        jj_consume_token(UNIQUE);
                         modifier |= ASTFunctionDeclaration.MODIFIER_UNIQUE;
        break;
      default:
        jj_la1[25] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[26] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INFIX:
    case PREFIX:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INFIX:
        jj_consume_token(INFIX);
        as = jj_consume_token(OP_IDENTIFIER);
        precedence = jj_consume_token(NATURAL);
               modifier |= ASTFunctionDeclaration.MODIFIER_INFIX;
        break;
      case PREFIX:
        jj_consume_token(PREFIX);
        as = jj_consume_token(OP_IDENTIFIER);
        precedence = jj_consume_token(NATURAL);
               modifier |= ASTFunctionDeclaration.MODIFIER_PREFIX;
        break;
      default:
        jj_la1[27] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[28] = jj_gen;
      ;
    }
      {if (true) return new ASTFunctionDeclaration(range, name, tyrefs, modifier, as, precedence);}
    throw new Error("Missing return statement in function");
  }

  final public ASTBinderDeclarationBlock BinderDeclarationBlock() throws ParseException {
  Token first;
  ASTBinderDeclaration bd;
  List<ASTBinderDeclaration> list = new ArrayList<ASTBinderDeclaration>();
    first = jj_consume_token(BINDER);
    label_14:
    while (true) {
      bd = BinderDeclaration();
                                                  list.add(bd);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case TYVAR_IDENTIFIER:
      case SCHEMA_TYPE_IDENTIFIER:
      case IDENTIFIER:
        ;
        break;
      default:
        jj_la1[29] = jj_gen;
        break label_14;
      }
    }
             {if (true) return new ASTBinderDeclarationBlock(first, list);}
    throw new Error("Missing return statement in function");
  }

  final public ASTBinderDeclaration BinderDeclaration() throws ParseException {
  ASTType range, varty, ty;
  Token name;
  List<ASTType> tyrefs = new ArrayList<ASTType>();
    range = TypeRef();
    jj_consume_token(LEFTPAREN);
    name = jj_consume_token(BINDER_IDENTIFIER);
    varty = TypeRef();
    label_15:
    while (true) {
      jj_consume_token(SEMICOLON);
      ty = TypeRef();
                         tyrefs.add(ty);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SEMICOLON:
        ;
        break;
      default:
        jj_la1[30] = jj_gen;
        break label_15;
      }
    }
    jj_consume_token(RIGHTPAREN);
      {if (true) return new ASTBinderDeclaration(name, range, varty, tyrefs);}
    throw new Error("Missing return statement in function");
  }

  final public ASTProgramDeclaration ProgramDeclaration() throws ParseException {
  List<ASTStatement> statements;
  Token first, name, source=null;
    first = jj_consume_token(PROGRAM);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case PROGRAM_IDENTIFIER:
      name = jj_consume_token(PROGRAM_IDENTIFIER);
      break;
    case IDENTIFIER:
      name = jj_consume_token(IDENTIFIER);
      break;
    default:
      jj_la1[31] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SOURCE:
      jj_consume_token(SOURCE);
      source = jj_consume_token(STRING);
      break;
    default:
      jj_la1[32] = jj_gen;
      ;
    }
    statements = StatementList();
       {if (true) return new ASTProgramDeclaration(first, name, source, statements);}
    throw new Error("Missing return statement in function");
  }

  final public ASTAxiomDeclaration AxiomDeclaration() throws ParseException {
  Token name, first, t, v=null;
  ASTTerm term;
  List<Pair<Token, Token>> properties = new ArrayList<Pair<Token, Token>>();
    first = jj_consume_token(AXIOM);
    name = jj_consume_token(IDENTIFIER);
    term = Term();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TAGS:
      jj_consume_token(TAGS);
      label_16:
      while (true) {
        t = jj_consume_token(IDENTIFIER);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case STRING:
          v = jj_consume_token(STRING);
          break;
        default:
          jj_la1[33] = jj_gen;
          ;
        }
          properties.add(new Pair<Token, Token>(t, v));
          v = null;
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case IDENTIFIER:
          ;
          break;
        default:
          jj_la1[34] = jj_gen;
          break label_16;
        }
      }
      break;
    default:
      jj_la1[35] = jj_gen;
      ;
    }
    {if (true) return new ASTAxiomDeclaration(first, name, term, properties);}
    throw new Error("Missing return statement in function");
  }

  final public ASTRule RuleDeclaration() throws ParseException {
  List<ASTRuleElement> list = new ArrayList<ASTRuleElement>();
  List<ASTGoalAction> actions = new ArrayList<ASTGoalAction>();
  List<ASTRuleElement> aclist;
  List<Pair<Token, Token>> properties = new ArrayList<Pair<Token, Token>>();
  ASTRuleElement elem;
  ASTLocatedTerm lt;
  Token t, v = null, first, name, descr = null, target = null;
    first = jj_consume_token(RULE);
    name = jj_consume_token(IDENTIFIER);
    label_17:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case FIND:
      case WHERE:
      case ASSUME:
        ;
        break;
      default:
        jj_la1[36] = jj_gen;
        break label_17;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case FIND:
        t = jj_consume_token(FIND);
        lt = LocatedTerm(true);
                                    list.add(new ASTRuleFind(t, lt));
        break;
      case ASSUME:
        t = jj_consume_token(ASSUME);
        lt = LocatedTerm(false);
                                       list.add(new ASTRuleAssume(t, lt));
        break;
      case WHERE:
        t = jj_consume_token(WHERE);
        elem = WhereClause(t);
                                    list.add(elem);
        break;
      default:
        jj_la1[37] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case CLOSE:
    case NEWGOAL:
    case SAMEGOAL:
      label_18:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case CLOSE:
          t = jj_consume_token(CLOSE);
                      actions.add(new ASTGoalAction(t));
          break;
        case NEWGOAL:
        case SAMEGOAL:
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case SAMEGOAL:
            target = jj_consume_token(SAMEGOAL);
            break;
          case NEWGOAL:
            target = jj_consume_token(NEWGOAL);
            break;
          default:
            jj_la1[38] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case STRING:
            v = jj_consume_token(STRING);
            break;
          default:
            jj_la1[39] = jj_gen;
            ;
          }
          aclist = AddReplaces();
             actions.add(new ASTGoalAction(target, v, aclist));
          break;
        default:
          jj_la1[40] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case CLOSE:
        case NEWGOAL:
        case SAMEGOAL:
          ;
          break;
        default:
          jj_la1[41] = jj_gen;
          break label_18;
        }
      }
      break;
    case ADD:
    case REMOVE:
    case REPLACE:
      aclist = AddReplaces();
        actions.add(new ASTGoalAction(null, null, aclist));
      break;
    default:
      jj_la1[42] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DESCRIPTION:
      jj_consume_token(DESCRIPTION);
      descr = jj_consume_token(STRING);
      break;
    default:
      jj_la1[43] = jj_gen;
      ;
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TAGS:
      jj_consume_token(TAGS);
      label_19:
      while (true) {
        t = jj_consume_token(IDENTIFIER);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case STRING:
          v = jj_consume_token(STRING);
          break;
        default:
          jj_la1[44] = jj_gen;
          ;
        }
          properties.add(new Pair<Token, Token>(t, v));
          v = null;
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case IDENTIFIER:
          ;
          break;
        default:
          jj_la1[45] = jj_gen;
          break label_19;
        }
      }
      break;
    default:
      jj_la1[46] = jj_gen;
      ;
    }
    {if (true) return new ASTRule(first, name, list, actions, descr, properties);}
    throw new Error("Missing return statement in function");
  }

  final public ASTLocatedTerm LocatedTerm(boolean bothAllowed) throws ParseException {
        ASTTerm rt;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SEP:
      jj_consume_token(SEP);
      rt = Term();
          {if (true) return new ASTLocatedTerm(rt, MatchingLocation.SUCCEDENT);}
      break;
    case LEFTPAREN:
    case LEFTCURLY:
    case LEFTDSQUARE:
    case OP_IDENTIFIER:
    case IDENTIFIER:
      rt = Term();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SEP:
        jj_consume_token(SEP);
             {if (true) return new ASTLocatedTerm(rt, MatchingLocation.ANTECEDENT);}
        break;
      default:
        jj_la1[47] = jj_gen;
        ;
      }
        if(!bothAllowed) {
          generateParserException(new int[] { SEP });
        }
        {if (true) return new ASTLocatedTerm(rt, MatchingLocation.BOTH);}
      break;
    default:
      jj_la1[48] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final public List<ASTRuleElement> AddReplaces() throws ParseException {
        Token t;
        ASTTerm term;
        ASTLocatedTerm lt;
        List<ASTRuleElement> list = new ArrayList<ASTRuleElement>();
    label_20:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ADD:
        t = jj_consume_token(ADD);
        lt = LocatedTerm(false);
                                    list.add(new ASTRuleAdd(t, lt));
        break;
      case REPLACE:
        t = jj_consume_token(REPLACE);
        term = Term();
                              list.add(new ASTRuleReplace(t, term));
        break;
      case REMOVE:
        t = jj_consume_token(REMOVE);
                 list.add(new ASTRuleRemove(t));
        break;
      default:
        jj_la1[49] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ADD:
      case REMOVE:
      case REPLACE:
        ;
        break;
      default:
        jj_la1[50] = jj_gen;
        break label_20;
      }
    }
    {if (true) return list;}
    throw new Error("Missing return statement in function");
  }

  final public ASTWhereClause WhereClause(Token headToken) throws ParseException {
        Token t;
        ASTTerm term;
        boolean inverted = false;
        List<ASTTerm> args = new ArrayList<ASTTerm>();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case NOT:
      jj_consume_token(NOT);
                 inverted = true;
      break;
    default:
      jj_la1[51] = jj_gen;
      ;
    }
    t = jj_consume_token(IDENTIFIER);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LEFTPAREN:
    case LEFTCURLY:
    case LEFTDSQUARE:
    case OP_IDENTIFIER:
    case IDENTIFIER:
      term = Term();
                           args.add(term);
      label_21:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[52] = jj_gen;
          break label_21;
        }
        jj_consume_token(COMMA);
        term = Term();
                                 args.add(term);
      }
      break;
    default:
      jj_la1[53] = jj_gen;
      ;
    }
         {if (true) return new ASTWhereClause(headToken, inverted, t, args);}
    throw new Error("Missing return statement in function");
  }

//
// This file contains partial parser definition for terms only
//

// a greedy term ... read the whole stream
// needed for parsing terms
  final public ASTTerm TermEOF() throws ParseException {
  ASTTerm term;
          token_source.SwitchTo(PROTECTED);
    term = Term();
    jj_consume_token(0);
          {if (true) return term;}
    throw new Error("Missing return statement in function");
  }

  final public ASTTerm Term() throws ParseException {
  ASTTerm term;
  List<ASTTerm> list = new ArrayList<ASTTerm>();
  int depth = 0;
    label_22:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case OP_IDENTIFIER:
        OpIdentifier();
        break;
      case LEFTPAREN:
        jj_consume_token(LEFTPAREN);
        break;
      case LEFTDSQUARE:
        jj_consume_token(LEFTDSQUARE);
        break;
      case IDENTIFIER:
        jj_consume_token(IDENTIFIER);
        break;
      case LEFTCURLY:
        jj_consume_token(LEFTCURLY);
        break;
      default:
        jj_la1[54] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LEFTPAREN:
      case LEFTCURLY:
      case LEFTDSQUARE:
      case OP_IDENTIFIER:
      case IDENTIFIER:
        ;
        break;
      default:
        jj_la1[55] = jj_gen;
        break label_22;
      }
    }
  }

  final public ASTTerm ModalityTerm() throws ParseException {
  ASTTerm term;
  ASTProgramTerm pt;
  Token id;
  List<ASTAssignment> assignments = Collections.emptyList();
  boolean optional = false;
    if (jj_2_1(3)) {
      jj_consume_token(LEFTCURLY);
      id = jj_consume_token(IDENTIFIER);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case RIGHTCURLY:
        jj_consume_token(RIGHTCURLY);
        break;
      case RIGHTCURLYOPTIONAL:
        jj_consume_token(RIGHTCURLYOPTIONAL);
                         optional=true;
        break;
      default:
        jj_la1[56] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      term = ModalityTerm();
              {if (true) return new ASTSchemaUpdateTerm(id, optional, term);}
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LEFTCURLY:
        jj_consume_token(LEFTCURLY);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SCHEMA_IDENTIFIER:
        case INTERNAL_IDENTIFIER:
        case IDENTIFIER:
          assignments = ParallelAssignment();
          break;
        default:
          jj_la1[57] = jj_gen;
          ;
        }
        jj_consume_token(RIGHTCURLY);
        term = ModalityTerm();
              {if (true) return new ASTUpdateTerm(assignments, term);}
        break;
      case LEFTSQUARE:
      case LEFTDIAMOND:
      case LEFTDSQUARE:
      case LEFTANYMOD:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LEFTSQUARE:
          jj_consume_token(LEFTSQUARE);
          pt = ProgramTerm_Content(Modality.BOX);
          jj_consume_token(RIGHTSQUARE);
          break;
        case LEFTDSQUARE:
          jj_consume_token(LEFTDSQUARE);
          pt = ProgramTerm_Content(Modality.BOX_TERMINATION);
          jj_consume_token(RIGHTSQUARE);
          jj_consume_token(RIGHTSQUARE);
          break;
        case LEFTDIAMOND:
          jj_consume_token(LEFTDIAMOND);
          pt = ProgramTerm_Content(Modality.DIAMOND);
          jj_consume_token(RIGHDIAMOND);
          break;
        case LEFTANYMOD:
          jj_consume_token(LEFTANYMOD);
          pt = ProgramTerm_Content(Modality.ANY);
          jj_consume_token(RIGHTANYMOD);
          break;
        default:
          jj_la1[58] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        term = ModalityTerm();
              pt.addChild(term); {if (true) return pt;}
        break;
      case LEFTPAREN:
      case VAR:
      case NATURAL:
      case SCHEMA_IDENTIFIER:
      case INTERNAL_IDENTIFIER:
      case META_IDENTIFIER:
      case IDENTIFIER:
        term = AsTerm();
              {if (true) return term;}
        break;
      default:
        jj_la1[59] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    throw new Error("Missing return statement in function");
  }

  final public ASTAssignment Assignment() throws ParseException {
        ASTTerm target;
        ASTTerm term;
        List<ASTTerm> arguments = null;
        Token t = null, symbol = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SCHEMA_IDENTIFIER:
      target = SchemaVariable();
      break;
    case INTERNAL_IDENTIFIER:
    case IDENTIFIER:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IDENTIFIER:
        t = jj_consume_token(IDENTIFIER);
        break;
      case INTERNAL_IDENTIFIER:
        t = jj_consume_token(INTERNAL_IDENTIFIER);
        break;
      default:
        jj_la1[60] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
                  target = new ASTIdentifierTerm(t);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LEFTSQUARE:
        symbol = jj_consume_token(LEFTSQUARE);
                  arguments = new ArrayList<ASTTerm>();
        term = Term();
                  arguments.add(term);
        label_23:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[61] = jj_gen;
            break label_23;
          }
          jj_consume_token(COMMA);
          term = Term();
                  arguments.add(term);
        }
        jj_consume_token(RIGHTSQUARE);
        break;
      default:
        jj_la1[62] = jj_gen;
        ;
      }
      break;
    default:
      jj_la1[63] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(ASSIGN);
    term = Term();
            if(arguments != null) {
               // we cannot use the same ast node twice (it's tree after all), 
               // so simply create an identical one.
               ASTTerm targetCopy = new ASTIdentifierTerm(t);
               term = new ASTMapOperationTerm(symbol, targetCopy, arguments, term);
            }
            {if (true) return new ASTAssignment(target, term);}
    throw new Error("Missing return statement in function");
  }

  final public List<ASTAssignment> ParallelAssignment() throws ParseException {
  Token t;
  ASTTerm term;
  ASTAssignment assignment;
  List<ASTAssignment> assignments = new ArrayList<ASTAssignment>();
    assignment = Assignment();
                  assignments.add(assignment);
    label_24:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PARALLEL:
        ;
        break;
      default:
        jj_la1[64] = jj_gen;
        break label_24;
      }
      jj_consume_token(PARALLEL);
      assignment = Assignment();
                  assignments.add(assignment);
    }
            {if (true) return assignments;}
    throw new Error("Missing return statement in function");
  }

  final public ASTProgramTerm ProgramTerm_Content(Modality modality) throws ParseException {
  Token t, label, progref;
  ASTStatement matchStatement = null, st;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SCHEMA_IDENTIFIER:
      label = jj_consume_token(SCHEMA_IDENTIFIER);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COLON:
        jj_consume_token(COLON);
        if (jj_2_2(2)) {
          matchStatement = Statement();
        } else {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case IDENTIFIER:
            matchStatement = SchematicAssignmentStatement();
            break;
          default:
            jj_la1[65] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
        break;
      default:
        jj_la1[66] = jj_gen;
        ;
      }
             {if (true) return new ASTProgramTerm(label, modality, matchStatement);}
      break;
    case NATURAL:
      label = jj_consume_token(NATURAL);
      jj_consume_token(SEMICOLON);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PROGRAM_IDENTIFIER:
        progref = jj_consume_token(PROGRAM_IDENTIFIER);
        break;
      case IDENTIFIER:
        progref = jj_consume_token(IDENTIFIER);
        break;
      default:
        jj_la1[67] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
           {if (true) return new ASTProgramTerm(label, modality, progref);}
      break;
    default:
      jj_la1[68] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final public ASTTerm AsTerm() throws ParseException {
  ASTTerm term;
  ASTType type;
    term = MapAccessTerm();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case AS:
      jj_consume_token(AS);
      type = TypeRef();
              term = new ASTAsType(term, type);
      break;
    default:
      jj_la1[69] = jj_gen;
      ;
    }
           {if (true) return term;}
    throw new Error("Missing return statement in function");
  }

  final public ASTTerm MapAccessTerm() throws ParseException {
  List<ASTTerm> args = new ArrayList<ASTTerm>();
  ASTTerm result, t;
  Token symbol;
  ASTTerm assignment = null;
    result = BaseTerm();
    label_25:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LEFTSQUARE:
        ;
        break;
      default:
        jj_la1[70] = jj_gen;
        break label_25;
      }
      symbol = jj_consume_token(LEFTSQUARE);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LEFTPAREN:
      case LEFTCURLY:
      case LEFTDSQUARE:
      case OP_IDENTIFIER:
      case IDENTIFIER:
        t = Term();
                     args.add(t);
        label_26:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[71] = jj_gen;
            break label_26;
          }
          jj_consume_token(COMMA);
          t = Term();
                            args.add(t);
        }
        break;
      default:
        jj_la1[72] = jj_gen;
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ASSIGN:
        jj_consume_token(ASSIGN);
        assignment = Term();
        break;
      default:
        jj_la1[73] = jj_gen;
        ;
      }
      jj_consume_token(RIGHTSQUARE);
           result = new ASTMapOperationTerm(symbol, result, args, assignment);
           // bugfix:
           args.clear();
           assignment = null;
    }
      {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  final public ASTTerm BaseTerm() throws ParseException {
  ASTTerm term;
    if (jj_2_3(2)) {
      jj_consume_token(LEFTPAREN);
      term = BinderTerm();
      jj_consume_token(RIGHTPAREN);
    } else if (jj_2_4(2)) {
      jj_consume_token(LEFTPAREN);
      term = TypevarBinderTerm();
      jj_consume_token(RIGHTPAREN);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LEFTPAREN:
        jj_consume_token(LEFTPAREN);
        term = Term();
        jj_consume_token(RIGHTPAREN);
        break;
      case VAR:
        term = ExplicitVariableTerm();
        break;
      case INTERNAL_IDENTIFIER:
      case META_IDENTIFIER:
      case IDENTIFIER:
        term = ApplicationTerm();
        break;
      case SCHEMA_IDENTIFIER:
        term = SchemaVariable();
        break;
      case NATURAL:
        term = NumberLiteral();
        break;
      default:
        jj_la1[74] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
          {if (true) return term;}
    throw new Error("Missing return statement in function");
  }

  final public ASTTerm ExplicitVariableTerm() throws ParseException {
  Token firstToken, varToken;
    firstToken = jj_consume_token(VAR);
    varToken = jj_consume_token(IDENTIFIER);
        {if (true) return new ASTExplicitVariableTerm(firstToken, varToken);}
    throw new Error("Missing return statement in function");
  }

  final public ASTBinderTerm BinderTerm() throws ParseException {
  Token binderToken;
  ASTTerm t;
  Pair<Token, ASTType> bound;
  List<Pair<Token, ASTType>> boundVars = new ArrayList<Pair<Token, ASTType>>();
  LinkedList<ASTTerm> subterms = new LinkedList<ASTTerm>();
    binderToken = jj_consume_token(BINDER_IDENTIFIER);
    bound = BoundVariable();
                                  boundVars.add(bound);
    label_27:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[75] = jj_gen;
        break label_27;
      }
      jj_consume_token(COMMA);
      bound = BoundVariable();
                                        boundVars.add(bound);
    }
    label_28:
    while (true) {
      jj_consume_token(SEMICOLON);
      t = Term();
                         subterms.add(t);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SEMICOLON:
        ;
        break;
      default:
        jj_la1[76] = jj_gen;
        break label_28;
      }
    }
     {if (true) return new ASTBinderTerm(binderToken, boundVars, subterms);}
    throw new Error("Missing return statement in function");
  }

  final public Pair<Token, ASTType> BoundVariable() throws ParseException {
  Token varToken;
  ASTType type = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IDENTIFIER:
      varToken = jj_consume_token(IDENTIFIER);
      break;
    case SCHEMA_IDENTIFIER:
      varToken = jj_consume_token(SCHEMA_IDENTIFIER);
      break;
    default:
      jj_la1[77] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case AS:
      jj_consume_token(AS);
      type = TypeRef();
      break;
    default:
      jj_la1[78] = jj_gen;
      ;
    }
      {if (true) return Pair.make(varToken, type);}
    throw new Error("Missing return statement in function");
  }

  final public ASTTypevarBinderTerm TypevarBinderTerm() throws ParseException {
  Token binderToken;
  ASTType type;
  ASTTerm t;
  List<ASTTerm> subterms = new ArrayList<ASTTerm>();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ALL_TY:
      binderToken = jj_consume_token(ALL_TY);
      break;
    case EX_TY:
      binderToken = jj_consume_token(EX_TY);
      break;
    default:
      jj_la1[79] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    type = BindableTypeRef();
    jj_consume_token(SEMICOLON);
    t = Term();
     {if (true) return new ASTTypevarBinderTerm(binderToken, type, t);}
    throw new Error("Missing return statement in function");
  }

  final public ASTType TypeRef() throws ParseException {
  Token token;
  List<ASTType> args = new ArrayList<ASTType>();
  ASTType ty;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IDENTIFIER:
      token = jj_consume_token(IDENTIFIER);
      if (jj_2_5(2)) {
        jj_consume_token(LEFTPAREN);
        ty = TypeRef();
                                     args.add(ty);
        label_29:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[80] = jj_gen;
            break label_29;
          }
          jj_consume_token(COMMA);
          ty = TypeRef();
                                                     args.add(ty);
        }
        jj_consume_token(RIGHTPAREN);
      } else {
        ;
      }
                  {if (true) return new ASTTypeApplication(token, args);}
      break;
    case TYVAR_IDENTIFIER:
    case SCHEMA_TYPE_IDENTIFIER:
      ty = BindableTypeRef();
                                       {if (true) return ty;}
      break;
    default:
      jj_la1[81] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

/* type references that can be used for type binders.
 * TypeApplications are not allowed */
  final public ASTType BindableTypeRef() throws ParseException {
  Token token;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TYVAR_IDENTIFIER:
      token = jj_consume_token(TYVAR_IDENTIFIER);
                  {if (true) return new ASTTypeVar(token);}
      break;
    case SCHEMA_TYPE_IDENTIFIER:
      token = jj_consume_token(SCHEMA_TYPE_IDENTIFIER);
                  {if (true) return new ASTSchemaType(token);}
      break;
    default:
      jj_la1[82] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final public ASTTerm ApplicationTerm() throws ParseException {
  ASTTerm t;
  List<ASTTerm> subterms = new ArrayList<ASTTerm>();
  ASTTerm result;
  Token symbol;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IDENTIFIER:
      symbol = jj_consume_token(IDENTIFIER);
      break;
    case META_IDENTIFIER:
      symbol = jj_consume_token(META_IDENTIFIER);
      break;
    case INTERNAL_IDENTIFIER:
      symbol = jj_consume_token(INTERNAL_IDENTIFIER);
      break;
    default:
      jj_la1[83] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LEFTPAREN:
      jj_consume_token(LEFTPAREN);
      t = Term();
                     subterms.add(t);
      label_30:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[84] = jj_gen;
          break label_30;
        }
        jj_consume_token(COMMA);
        t = Term();
                           subterms.add(t);
      }
      jj_consume_token(RIGHTPAREN);
      break;
    default:
      jj_la1[85] = jj_gen;
      ;
    }
      if(subterms.size() > 0)
        result = new ASTApplicationTerm(symbol, subterms);
      else
        result = new ASTIdentifierTerm(symbol);

      {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  final public ASTTerm OpIdentifier() throws ParseException {
  Token t;
    t = jj_consume_token(OP_IDENTIFIER);
    {if (true) return new ASTOperatorIdentifierTerm(t);}
    throw new Error("Missing return statement in function");
  }

  final public ASTTerm Identifier() throws ParseException {
  Token t;
    t = jj_consume_token(IDENTIFIER);
    {if (true) return new ASTIdentifierTerm(t);}
    throw new Error("Missing return statement in function");
  }

  final public ASTTerm InternalIdentifier() throws ParseException {
  Token t;
    t = jj_consume_token(INTERNAL_IDENTIFIER);
    {if (true) return new ASTIdentifierTerm(t);}
    throw new Error("Missing return statement in function");
  }

  final public ASTNumberLiteralTerm NumberLiteral() throws ParseException {
  Token t;
    t = jj_consume_token(NATURAL);
    {if (true) return new ASTNumberLiteralTerm(t);}
    throw new Error("Missing return statement in function");
  }

  final public ASTSchemaVariableTerm SchemaVariable() throws ParseException {
        Token t;
    t = jj_consume_token(SCHEMA_IDENTIFIER);
    {if (true) return new ASTSchemaVariableTerm(t);}
    throw new Error("Missing return statement in function");
  }

//
// This file contains partial parser definition for programs only
//
  final public List<ASTStatement> StatementList() throws ParseException {
        List<ASTStatement> list = new ArrayList<ASTStatement>();
        ASTStatement st;
    label_31:
    while (true) {
      if (jj_2_6(2)) {
        st = Statement();
                           list.add(st);
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SOURCELINE:
          st = SourceLineStatement();
                                     list.add(st);
          break;
        case IDENTIFIER:
          st = LabelStatement();
                                list.add(st);
          break;
        default:
          jj_la1[86] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ASSUME:
      case ASSERT:
      case GOTO:
      case HAVOC:
      case END:
      case _SKIP:
      case SKIP_LOOP_INV:
      case SOURCELINE:
      case SCHEMA_IDENTIFIER:
      case INTERNAL_IDENTIFIER:
      case IDENTIFIER:
        ;
        break;
      default:
        jj_la1[87] = jj_gen;
        break label_31;
      }
    }
          {if (true) return list;}
    throw new Error("Missing return statement in function");
  }

  final public ASTSourceLineStatement SourceLineStatement() throws ParseException {
        Token kw, argument;
    kw = jj_consume_token(SOURCELINE);
    argument = jj_consume_token(NATURAL);
          {if (true) return new ASTSourceLineStatement(kw,argument);}
    throw new Error("Missing return statement in function");
  }

  final public ASTLabelStatement LabelStatement() throws ParseException {
        Token label;
    label = jj_consume_token(IDENTIFIER);
    jj_consume_token(COLON);
               {if (true) return new ASTLabelStatement(label);}
    throw new Error("Missing return statement in function");
  }

  final public ASTStatement Statement() throws ParseException {
        ASTTerm term;
        Token kw;
        ASTStatement result;
        List<ASTTerm> termList;
        List<ASTAssignment> asList;
        Token textAnnotation = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ASSERT:
      kw = jj_consume_token(ASSERT);
      term = Term();
                                    result = new ASTAssertStatement(kw, term);
      break;
    case ASSUME:
      kw = jj_consume_token(ASSUME);
      term = Term();
                                    result = new ASTAssumeStatement(kw, term);
      break;
    case END:
      kw = jj_consume_token(END);
                     result = new ASTEndStatement(kw);
      break;
    case SKIP_LOOP_INV:
      kw = jj_consume_token(SKIP_LOOP_INV);
      termList = Statement_TermList();
                      result = new ASTSkipStatement(kw, termList);
      break;
    case _SKIP:
      kw = jj_consume_token(_SKIP);
                      result = new ASTSkipStatement(kw);
      break;
    case HAVOC:
      kw = jj_consume_token(HAVOC);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IDENTIFIER:
        term = Identifier();
        break;
      case INTERNAL_IDENTIFIER:
        term = InternalIdentifier();
        break;
      case SCHEMA_IDENTIFIER:
        term = SchemaVariable();
        break;
      default:
        jj_la1[88] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
                      result = new ASTHavocStatement(kw, term);
      break;
    case SCHEMA_IDENTIFIER:
    case INTERNAL_IDENTIFIER:
    case IDENTIFIER:
      asList = ParallelAssignment();
               result = new ASTAssignmentStatement(asList);
      break;
    case GOTO:
      kw = jj_consume_token(GOTO);
      termList = Statement_TermList();
               result = new ASTGotoStatement(kw, termList);
      break;
    default:
      jj_la1[89] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SEMICOLON:
      jj_consume_token(SEMICOLON);
      textAnnotation = jj_consume_token(STRING);
             result.setTextAnnotation(textAnnotation);
      break;
    default:
      jj_la1[90] = jj_gen;
      ;
    }
          {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

/*
// In case we want to distinguish between goto labels and identifiers use this
// with goto statements and lables
List<ASTTerm> GotoTargetList():
{
    List<ASTTerm> targets = new LinkedList<ASTTerm>();
    ASTTerm target;
    Token t;
}
{
    ( target = SchemaVariable()
    | target = NumberLiteral()
    | t=<LABEL_IDENTIFIER> 
        { target=new ASTIdentifierTerm(t); }
    )
    { targets.add(target); }
    
    ( "," 
        ( target = SchemaVariable()
        | target = NumberLiteral()
        | t=<LABEL_IDENTIFIER> 
            { target=new ASTIdentifierTerm(t); }
        )
        { targets.add(target); }
    )?
    { return targets; }
}
*/
  final public List<ASTTerm> Statement_TermList() throws ParseException {
    List<ASTTerm> terms = new LinkedList<ASTTerm>();
    ASTTerm t;
    t = Term();
      terms.add(t);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COMMA:
      jj_consume_token(COMMA);
      t = Term();
          terms.add(t);
      break;
    default:
      jj_la1[91] = jj_gen;
      ;
    }
      {if (true) return terms;}
    throw new Error("Missing return statement in function");
  }

// Only used where matching contexts are allowed.
  final public ASTSchematicAssignmentStatement SchematicAssignmentStatement() throws ParseException {
  Token t;
    t = jj_consume_token(IDENTIFIER);
    {if (true) return new ASTSchematicAssignmentStatement(t);}
    throw new Error("Missing return statement in function");
  }

  private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_1(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(0, xla); }
  }

  private boolean jj_2_2(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_2(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(1, xla); }
  }

  private boolean jj_2_3(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_3(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(2, xla); }
  }

  private boolean jj_2_4(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_4(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(3, xla); }
  }

  private boolean jj_2_5(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_5(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(4, xla); }
  }

  private boolean jj_2_6(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_6(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(5, xla); }
  }

  private boolean jj_3R_61() {
    if (jj_scan_token(SCHEMA_TYPE_IDENTIFIER)) return true;
    return false;
  }

  private boolean jj_3R_54() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_60()) {
    jj_scanpos = xsp;
    if (jj_3R_61()) return true;
    }
    return false;
  }

  private boolean jj_3R_60() {
    if (jj_scan_token(TYVAR_IDENTIFIER)) return true;
    return false;
  }

  private boolean jj_3_4() {
    if (jj_scan_token(LEFTPAREN)) return true;
    if (jj_3R_35()) return true;
    return false;
  }

  private boolean jj_3_3() {
    if (jj_scan_token(LEFTPAREN)) return true;
    if (jj_3R_34()) return true;
    return false;
  }

  private boolean jj_3R_52() {
    if (jj_3R_58()) return true;
    return false;
  }

  private boolean jj_3R_47() {
    if (jj_3R_54()) return true;
    return false;
  }

  private boolean jj_3_6() {
    if (jj_3R_33()) return true;
    return false;
  }

  private boolean jj_3_5() {
    if (jj_scan_token(LEFTPAREN)) return true;
    if (jj_3R_36()) return true;
    return false;
  }

  private boolean jj_3R_66() {
    if (jj_scan_token(LEFTSQUARE)) return true;
    return false;
  }

  private boolean jj_3R_36() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_46()) {
    jj_scanpos = xsp;
    if (jj_3R_47()) return true;
    }
    return false;
  }

  private boolean jj_3R_46() {
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  private boolean jj_3R_49() {
    if (jj_3R_48()) return true;
    return false;
  }

  private boolean jj_3R_64() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(78)) {
    jj_scanpos = xsp;
    if (jj_scan_token(75)) return true;
    }
    xsp = jj_scanpos;
    if (jj_3R_66()) jj_scanpos = xsp;
    return false;
  }

  private boolean jj_3R_63() {
    if (jj_3R_58()) return true;
    return false;
  }

  private boolean jj_3R_59() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_63()) {
    jj_scanpos = xsp;
    if (jj_3R_64()) return true;
    }
    if (jj_scan_token(ASSIGN)) return true;
    return false;
  }

  private boolean jj_3R_58() {
    if (jj_scan_token(SCHEMA_IDENTIFIER)) return true;
    return false;
  }

  private boolean jj_3R_51() {
    if (jj_3R_57()) return true;
    return false;
  }

  private boolean jj_3R_32() {
    if (jj_scan_token(RIGHTCURLYOPTIONAL)) return true;
    return false;
  }

  private boolean jj_3R_35() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(57)) {
    jj_scanpos = xsp;
    if (jj_scan_token(58)) return true;
    }
    return false;
  }

  private boolean jj_3R_57() {
    if (jj_scan_token(INTERNAL_IDENTIFIER)) return true;
    return false;
  }

  private boolean jj_3R_50() {
    if (jj_3R_56()) return true;
    return false;
  }

  private boolean jj_3R_56() {
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  private boolean jj_3_1() {
    if (jj_scan_token(LEFTCURLY)) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(42)) {
    jj_scanpos = xsp;
    if (jj_3R_32()) return true;
    }
    return false;
  }

  private boolean jj_3R_45() {
    if (jj_scan_token(SEMICOLON)) return true;
    return false;
  }

  private boolean jj_3R_44() {
    if (jj_scan_token(GOTO)) return true;
    if (jj_3R_49()) return true;
    return false;
  }

  private boolean jj_3R_43() {
    if (jj_3R_53()) return true;
    return false;
  }

  private boolean jj_3R_65() {
    if (jj_scan_token(OP_IDENTIFIER)) return true;
    return false;
  }

  private boolean jj_3_2() {
    if (jj_3R_33()) return true;
    return false;
  }

  private boolean jj_3R_42() {
    if (jj_scan_token(HAVOC)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_50()) {
    jj_scanpos = xsp;
    if (jj_3R_51()) {
    jj_scanpos = xsp;
    if (jj_3R_52()) return true;
    }
    }
    return false;
  }

  private boolean jj_3R_41() {
    if (jj_scan_token(_SKIP)) return true;
    return false;
  }

  private boolean jj_3R_40() {
    if (jj_scan_token(SKIP_LOOP_INV)) return true;
    if (jj_3R_49()) return true;
    return false;
  }

  private boolean jj_3R_39() {
    if (jj_scan_token(END)) return true;
    return false;
  }

  private boolean jj_3R_38() {
    if (jj_scan_token(ASSUME)) return true;
    if (jj_3R_48()) return true;
    return false;
  }

  private boolean jj_3R_37() {
    if (jj_scan_token(ASSERT)) return true;
    if (jj_3R_48()) return true;
    return false;
  }

  private boolean jj_3R_34() {
    if (jj_scan_token(BINDER_IDENTIFIER)) return true;
    return false;
  }

  private boolean jj_3R_33() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_37()) {
    jj_scanpos = xsp;
    if (jj_3R_38()) {
    jj_scanpos = xsp;
    if (jj_3R_39()) {
    jj_scanpos = xsp;
    if (jj_3R_40()) {
    jj_scanpos = xsp;
    if (jj_3R_41()) {
    jj_scanpos = xsp;
    if (jj_3R_42()) {
    jj_scanpos = xsp;
    if (jj_3R_43()) {
    jj_scanpos = xsp;
    if (jj_3R_44()) return true;
    }
    }
    }
    }
    }
    }
    }
    xsp = jj_scanpos;
    if (jj_3R_45()) jj_scanpos = xsp;
    return false;
  }

  private boolean jj_3R_62() {
    if (jj_3R_65()) return true;
    return false;
  }

  private boolean jj_3R_55() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_62()) {
    jj_scanpos = xsp;
    if (jj_scan_token(37)) {
    jj_scanpos = xsp;
    if (jj_scan_token(46)) {
    jj_scanpos = xsp;
    if (jj_scan_token(78)) {
    jj_scanpos = xsp;
    if (jj_scan_token(41)) return true;
    }
    }
    }
    }
    return false;
  }

  private boolean jj_3R_53() {
    if (jj_3R_59()) return true;
    return false;
  }

  private boolean jj_3R_48() {
    Token xsp;
    if (jj_3R_55()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_55()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  /** Generated Token Manager. */
  public ParserTokenManager token_source;
  SimpleCharStream jj_input_stream;
  /** Current token. */
  public Token token;
  /** Next token. */
  public Token jj_nt;
  private int jj_ntk;
  private Token jj_scanpos, jj_lastpos;
  private int jj_la;
  private int jj_gen;
  final private int[] jj_la1 = new int[92];
  static private int[] jj_la1_0;
  static private int[] jj_la1_1;
  static private int[] jj_la1_2;
  static {
      jj_la1_init_0();
      jj_la1_init_1();
      jj_la1_init_2();
   }
   private static void jj_la1_init_0() {
      jj_la1_0 = new int[] {0x9918c000,0x9918c000,0x4000000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x2000,0x2000,0x2200000,0x2200000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x40000,0x40000,0x400000,0x0,0x410000,0x410000,0x60411000,0x20000,0x0,0x0,0x0,0x0,0x0,0x60001000,0x60001000,0x800000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,};
   }
   private static void jj_la1_init_1() {
      jj_la1_1 = new int[] {0x2,0x2,0x0,0x20000,0x4220,0x20000,0x4220,0x800000,0x0,0x40000,0x0,0x0,0x0,0x20000,0x20,0x400000,0x20000,0x200,0x20000,0x0,0x280,0x0,0x0,0x20000,0x20,0x8,0x8,0x0,0x0,0x0,0x200000,0x0,0x0,0x0,0x0,0x4,0x8000010,0x8000010,0x1,0x0,0x1,0x1,0x1,0x0,0x0,0x0,0x4,0x800000,0x804220,0x0,0x0,0x0,0x20000,0x4220,0x4220,0x4220,0xc00,0x0,0xd080,0x100d2a0,0x0,0x20000,0x80,0x0,0x80000,0x0,0x100000,0x0,0x0,0x400000,0x80,0x20000,0x4220,0x0,0x1000020,0x20000,0x200000,0x0,0x400000,0x6000000,0x20000,0x0,0x0,0x0,0x20000,0x20,0x0,0xf8000000,0x0,0xf8000000,0x200000,0x20000,};
   }
   private static void jj_la1_init_2() {
      jj_la1_2 = new int[] {0x0,0x0,0x0,0x0,0x6000,0x0,0x6000,0x0,0x4000,0x0,0x4000,0x20,0x4000,0x0,0x0,0x0,0x0,0x0,0x0,0x4300,0x4300,0x4300,0x4800,0x0,0x0,0x0,0x0,0x0,0x0,0x4300,0x0,0xc000,0x4,0x20,0x4000,0x0,0x0,0x0,0x0,0x20,0x0,0x0,0x0,0x0,0x20,0x4000,0x0,0x0,0x6000,0x0,0x0,0x0,0x0,0x6000,0x6000,0x6000,0x0,0x4c00,0x0,0x5c40,0x4800,0x0,0x0,0x4c00,0x0,0x4000,0x0,0xc000,0x440,0x0,0x0,0x0,0x6000,0x10,0x5c40,0x0,0x0,0x4400,0x0,0x0,0x0,0x4300,0x300,0x5800,0x0,0x0,0x4008,0x4c0b,0x4c00,0x4c03,0x0,0x0,};
   }
  final private JJCalls[] jj_2_rtns = new JJCalls[6];
  private boolean jj_rescan = false;
  private int jj_gc = 0;

  /** Constructor with InputStream. */
  public Parser(java.io.InputStream stream) {
     this(stream, null);
  }
  /** Constructor with InputStream and supplied encoding */
  public Parser(java.io.InputStream stream, String encoding) {
    try { jj_input_stream = new SimpleCharStream(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source = new ParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 92; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Reinitialise. */
  public void ReInit(java.io.InputStream stream) {
     ReInit(stream, null);
  }
  /** Reinitialise. */
  public void ReInit(java.io.InputStream stream, String encoding) {
    try { jj_input_stream.ReInit(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 92; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Constructor. */
  public Parser(java.io.Reader stream) {
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new ParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 92; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Reinitialise. */
  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 92; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Constructor with generated Token Manager. */
  public Parser(ParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 92; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Reinitialise. */
  public void ReInit(ParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 92; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJCalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  static private final class LookaheadSuccess extends java.lang.Error { }
  final private LookaheadSuccess jj_ls = new LookaheadSuccess();
  private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    if (jj_scanpos.kind != kind) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) throw jj_ls;
    return false;
  }


/** Get the next Token. */
  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

/** Get the specific Token. */
  final public Token getToken(int index) {
    Token t = token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.List<int[]> jj_expentries = new java.util.ArrayList<int[]>();
  private int[] jj_expentry;
  private int jj_kind = -1;
  private int[] jj_lasttokens = new int[100];
  private int jj_endpos;

  private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      jj_entries_loop: for (java.util.Iterator<?> it = jj_expentries.iterator(); it.hasNext();) {
        int[] oldentry = (int[])(it.next());
        if (oldentry.length == jj_expentry.length) {
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              continue jj_entries_loop;
            }
          }
          jj_expentries.add(jj_expentry);
          break jj_entries_loop;
        }
      }
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  /** Generate ParseException. */
  public ParseException generateParseException() {
    jj_expentries.clear();
    boolean[] la1tokens = new boolean[81];
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 92; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
          if ((jj_la1_2[i] & (1<<j)) != 0) {
            la1tokens[64+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 81; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.add(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = jj_expentries.get(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  /** Enable tracing. */
  final public void enable_tracing() {
  }

  /** Disable tracing. */
  final public void disable_tracing() {
  }

  private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 6; i++) {
    try {
      JJCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
            case 1: jj_3_2(); break;
            case 2: jj_3_3(); break;
            case 3: jj_3_4(); break;
            case 4: jj_3_5(); break;
            case 5: jj_3_6(); break;
          }
        }
        p = p.next;
      } while (p != null);
      } catch(LookaheadSuccess ls) { }
    }
    jj_rescan = false;
  }

  private void jj_save(int index, int xla) {
    JJCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

  static final class JJCalls {
    int gen;
    Token first;
    int arg;
    JJCalls next;
  }

}
