package de.uka.iti.pseudo.auto;

import java.io.File;

import de.uka.iti.pseudo.environment.Environment;
import de.uka.iti.pseudo.environment.creation.EnvironmentMaker;
import de.uka.iti.pseudo.parser.Parser;
import de.uka.iti.pseudo.parser.file.ASTFile;

public class TestTranslation {

    {
        ClassLoader.getSystemClassLoader().setDefaultAssertionStatus(true);
    }

    /**
     * @param args
     * @throws Exception
     */
    public static void main(String[] args) throws Exception {
        Parser fp = new Parser();
        ASTFile ast = fp.parseFile(new File("/tmp/tmp.p"));
        EnvironmentMaker em = new EnvironmentMaker(fp, ast, "none:test");
        Environment env = em.getEnvironment();

        SMTLib2Translator smt = new SMTLib2Translator(env);
        StringBuilder sb = new StringBuilder();
        smt.export(em.getProblemSequents().get(""), sb);
        System.out.println(sb);
    }

}
