//package de.uka.iti.pseudo.gui.editor;
//
//import java.io.File;
//import java.io.IOException;
//import java.io.InputStream;
//import java.io.StringBufferInputStream;
//import java.net.MalformedURLException;
//import java.net.URI;
//import java.net.URL;
//
//import javax.swing.event.HyperlinkEvent;
//
//import org.fife.ui.rsyntaxtextarea.RSyntaxDocument;
//import org.fife.ui.rsyntaxtextarea.RSyntaxTextArea;
//import org.fife.ui.rsyntaxtextarea.parser.AbstractParser;
//import org.fife.ui.rsyntaxtextarea.parser.DefaultParseResult;
//import org.fife.ui.rsyntaxtextarea.parser.ExtendedHyperlinkListener;
//import org.fife.ui.rsyntaxtextarea.parser.ParseResult;
//
//import de.uka.iti.pseudo.environment.EnvironmentException;
//import de.uka.iti.pseudo.environment.creation.EnvironmentCreationService;
//import de.uka.iti.pseudo.gui.Main;
//import de.uka.iti.pseudo.util.ExceptionDialog;
//import de.uka.iti.pseudo.util.Log;
//
//public class SyntaxCheckParser extends AbstractParser {
//
//    private final PFileEditor editor;
//    private EnvironmentCreationService syntaxChecker;
//
//
//    public SyntaxCheckParser(PFileEditor editor) {
//        this.editor = editor;
//        setHyperlinkListener(new LinkVisitor());
//    }
//
//    @Override
//    public ExtendedHyperlinkListener getHyperlinkListener() {
//        return null;
//    }
//
//    @Override
//    public URL getImageBase() {
//        try {
//            return editor.getEditedFile().toURI().toURL();
//        } catch (MalformedURLException e) {
//            throw new Error(e);
//        }
//    }
//
//    @Override
//    public ParseResult parse(RSyntaxDocument doc, String style) {
//
//        DefaultParseResult result = new DefaultParseResult(this);
//        URL url = null;
//        try {
//            // TODO is this conversion to a string too expensive?
//            // TODO find sth better here
//            String content = doc.getText(0, doc.getLength());
//            InputStream inputStream = new StringBufferInputStream(content);
//
//            File editedFile = editor.getEditedFile();
//            if(editedFile != null) {
//                url = editedFile.toURI().toURL();
//            } else {
//                url = new URL("none:unnamed.p");
//            }
//
//            // the checker may be null during initialisation. ...
//            if(syntaxChecker != null) {
//                syntaxChecker.createEnvironment(inputStream, url);
//            }
//
//            Log.log(Log.VERBOSE, "Syntax checked ... no errors");
//
//        } catch (EnvironmentException e) {
//            markError(e, url.toString().equals(e.getResource()));
//        } catch (Exception e) {
//            Log.stacktrace(Log.VERBOSE, e);
//            markError(e, false);
//        }
//
//        result.setParseTime(System.currentTimeMillis());
//        return result;
//    }
//
//    private class LinkVisitor implements ExtendedHyperlinkListener {
//
//        @Override
//        public void linkClicked(RSyntaxTextArea textArea, HyperlinkEvent e) {
//            try {
//                URI uri = e.getURL().toURI();
//                if(!"file".equals(uri.getScheme()))
//                    throw new IOException("Only file URLs can be opened in the editor");
//                File f = new File(uri);
//                Main.openEditor(f);
//            } catch (Exception ex) {
//                ExceptionDialog.showExceptionDialog(editor, ex);
//            }
//        }
//
//    }
//
//    public void setService(EnvironmentCreationService syntaxChecker) {
//        this.syntaxChecker = syntaxChecker;
//    }
//
//}
