# Created by RuleJustification
# Wed Jul 04 18:22:50 CEST 2012

(* Additional include (for proofs!) *)
include
  "../proveHelper.p"

include
  "$int.p"
  "$set.p"
  "$seqdefs.p"




rule seqSubSelf
  find seqSub(%a as seq(%'v1),0 as int,seqLen(%a as seq(%'v1)) as int) as seq(%'v1)
  samegoal
    replace %a as seq(%'v1)
  tags
    rewrite "concrete"
    derived ""

rule seqOutside1
  find seqGet(%a as seq(%'v1),%i as int) as %'v1
  assume $lt(%i,0) |-
  samegoal
    replace seqError as %'v1
  tags
    derived ""

rule seqOutside2
  find seqGet(%a as seq(%'v1),%i as int) as %'v1
  assume $gte(%i,seqLen(%a)) |-
  samegoal
    replace seqError as %'v1
  tags
    derived ""

rule lenOfSeqEmpty
  find seqLen(seqEmpty as seq(%'v2)) as int
  samegoal
    replace 0 as int
  tags
    rewrite "concrete"
    derived ""

rule getOfSeqEmpty
  find seqGet(seqEmpty as seq(%'v2),%i as int) as %'v2
  samegoal
    replace seqError as %'v2
  tags
    rewrite "concrete"
    derived ""

rule lenOfSeqSingleton
  find seqLen(seqSingleton(%x as %'x) as seq(%'x)) as int
  samegoal
    replace 1 as int
  tags
    rewrite "fol simp"
    derived ""

rule getOfSeqSingleton
  find seqGet(seqSingleton(%x as %'x) as seq(%'x),%i as int) as %'x
  samegoal
    replace cond($eq(%i as int,0 as int) as bool,%x as %'x,seqError as %'x) as %'x
  tags
    rewrite "fol simp"
    asAxiom ""
    derived ""

rule lenOfSeqConcat
  find seqLen(seqConcat(%seq as seq(%'v2),%seq2 as seq(%'v2)) as seq(%'v2)) as int
  samegoal
    replace $plus(seqLen(%seq as seq(%'v2)) as int,seqLen(%seq2 as seq(%'v2)) as int) as int
  tags
    rewrite "fol simp"
    asAxiom ""
    derived ""

rule seqLenOfSub
  find seqLen(seqSub(%a as seq(%'v2),%from as int,%to as int) as seq(%'v2)) as int
  samegoal
    replace cond($lte(%from as int,%to as int) as bool,$minus(%to as int,%from as int) as int,0 as int) as int
  tags
    rewrite "fol simp"
    asAxiom ""
    derived ""

rule seqGetOfSub
  find seqGet(seqSub(%a as seq(%'v5),%from as int,%to as int) as seq(%'v5),%i as int) as %'v5
  samegoal
    replace cond($and($lte(0 as int,%i as int) as bool,$lt(%i as int,$minus(%to as int,%from as int) as int) as bool) as bool,seqGet(%a as seq(%'v5),$plus(%i as int,%from as int) as int) as %'v5,seqError as %'v5) as %'v5
  tags
    rewrite "fol simp"
    asAxiom ""
    derived ""

rule lenOfSeqReverse
  find seqLen(seqReverse(%seq as seq(%'v2)) as seq(%'v2)) as int
  samegoal
    replace seqLen(%seq as seq(%'v2)) as int
  tags
    rewrite "fol simp"
    asAxiom ""
    derived ""

rule getOfSeqReverse
  find seqGet(seqReverse(%seq as seq(%'v2)) as seq(%'v2),%i as int) as %'v2
  samegoal
    replace seqGet(%seq as seq(%'v2),$minus($minus(seqLen(%seq as seq(%'v2)) as int,1 as int) as int,%i as int) as int) as %'v2
  tags
    rewrite "fol simp"
    asAxiom ""
    derived ""


function seq('v2) seq


problem
  $eq(seqConcat(seq as seq('v2),seqEmpty as seq('v2)) as seq('v2),seq as seq('v2)) as bool
