# Created by RuleJustification
# Tue Jul 03 17:58:03 CEST 2012

(* Additional include (for proofs!) *)
include
  "../proveHelper.p"

include
  "$setdefs.p"
  "$int.p"




axiom cut_finiteness
  (\T_all 'a;(\forall s as set('a);$impl(finite(fullset as set('a)) as bool,finite(\var s as set('a)) as bool) as bool) as bool) as bool

axiom card_non_negative
  (\T_all 'a;(\forall s as set('a);$gte(card(\var s as set('a)) as int,0 as int) as bool) as bool) as bool

rule set_equality
  find $eq(%a as set(%'e),%b as set(%'e)) as bool
  where freshVar %e, %a, %b
  samegoal
    replace (\forall %e as %'e;$equiv($mem(%e as %'e,%a as set(%'e)) as bool,$mem(%e as %'e,%b as set(%'e)) as bool) as bool) as bool
  tags
    derived ""

rule emptyset_in_anyset
  find $subset(emptyset as set(%'v2),%s as set(%'v2)) as bool
  samegoal
    replace true as bool
  tags
    rewrite "concrete"
    asAxiom ""
    derived ""
    verbosity "8"

rule nothing_in_emptyset
  find $mem(%x as %'x,emptyset as set(%'x)) as bool
  samegoal
    replace false as bool
  tags
    rewrite "concrete"
    asAxiom ""
    derived ""
    verbosity "8"

rule emptyset_equals
  find $eq(emptyset as set(%'x),%s as set(%'x)) as bool
  where freshVar %x, %s
  samegoal
    replace (\forall %x as %'x;$not($mem(%x as %'x,%s as set(%'x)) as bool) as bool) as bool
  tags
    rewrite "concrete"
    derived ""
    verbosity "6"

rule emptyset_equals2
  find $eq(%s as set(%'x),emptyset as set(%'x)) as bool
  where freshVar %x, %s
  samegoal
    replace (\forall %x as %'x;$not($mem(%x as %'x,%s as set(%'x)) as bool) as bool) as bool
  tags
    rewrite "concrete"
    derived ""
    verbosity "6"

rule anyset_in_fullset
  find $subset(%s as set(%'v2),fullset as set(%'v2)) as bool
  samegoal
    replace true as bool
  tags
    rewrite "concrete"
    asAxiom ""
    derived ""
    verbosity "8"

rule anything_in_fullset
  find $mem(%x as %'x,fullset as set(%'x)) as bool
  samegoal
    replace true as bool
  tags
    rewrite "concrete"
    asAxiom ""
    derived ""
    verbosity "8"

rule fullset_equals
  find $eq(fullset as set(%'x),%s as set(%'x)) as bool
  where freshVar %x, %s
  samegoal
    replace (\forall %x as %'x;$mem(%x as %'x,%s as set(%'x)) as bool) as bool
  tags
    rewrite "concrete"
    derived ""
    verbosity "6"

rule in_singleton
  find $mem(%x as %'y,singleton(%y as %'y) as set(%'y)) as bool
  samegoal
    replace $eq(%x as %'y,%y as %'y) as bool
  tags
    rewrite "fol simp"
    derived ""
    verbosity "8"

rule subset_singleton
  find $subset(%x as set(%'y),singleton(%y as %'y) as set(%'y)) as bool
  samegoal
    replace $or($eq(%x as set(%'y),emptyset as set(%'y)) as bool,$eq(%x as set(%'y),singleton(%y as %'y) as set(%'y)) as bool) as bool
  tags
    rewrite "fol simp"
    derived ""
    verbosity "8"

rule singleton_eq_singleton
  find $eq(singleton(%x as %'y) as set(%'y),singleton(%y as %'y) as set(%'y)) as bool
  samegoal
    replace $eq(%x as %'y,%y as %'y) as bool
  tags
    rewrite "fol simp"
    asAxiom ""
    derived ""
    verbosity "8"

rule in_diff
  find $mem(%x as %'x,$diff(%a as set(%'x),%b as set(%'x)) as set(%'x)) as bool
  samegoal
    replace $and($mem(%x as %'x,%a as set(%'x)) as bool,$not($mem(%x as %'x,%b as set(%'x)) as bool) as bool) as bool
  tags
    rewrite "fol simp"
    derived ""
    verbosity "6"

rule diff_is_conj
  find $diff(%x as set(%'v1),%y as set(%'v1)) as set(%'v1)
  samegoal
    replace $intersect(%x as set(%'v1),$complement(%y as set(%'v1)) as set(%'v1)) as set(%'v1)
  tags
    derived ""

rule diff_emptyset
  find $diff(%s as set(%'v2),emptyset as set(%'v2)) as set(%'v2)
  samegoal
    replace %s as set(%'v2)
  tags
    rewrite "concrete"
    derived ""
    verbosity "8"

rule diff_is_empty
  find $eq($diff(%s as set(%'v1),%t as set(%'v1)) as set(%'v1),emptyset as set(%'v1)) as bool
  samegoal
    replace $subset(%s as set(%'v1),%t as set(%'v1)) as bool
  tags
    derived ""

rule diff_same
  find $diff(%s as set(%'v1),%s as set(%'v1)) as set(%'v1)
  samegoal
    replace emptyset as set(%'v1)
  tags
    rewrite "concrete"
    derived ""

rule subset_def
  find $subset(%a as set(%'x),%b as set(%'x)) as bool
  where freshVar %x, %a, %b
  samegoal
    replace (\forall %x as %'x;$impl($mem(%x as %'x,%a as set(%'x)) as bool,$mem(%x as %'x,%b as set(%'x)) as bool) as bool) as bool

rule subset_refl
  find $subset(%a as set(%'v1),%a as set(%'v1)) as bool
  samegoal
    replace true as bool
  tags
    rewrite "fol simp"
    asAxiom ""
    derived ""
    verbosity "8"

rule subset_trans
  find $mem(%x,%s) |-
  assume $subset(%s,%t) |-
  where presentInAntecedent $mem(%x,%t)
  samegoal
    add $mem(%x as %'x,%t as set(%'x)) as bool |-
  tags
    rewrite "fol add"
    derived ""
    verbosity "6"

rule setminus_subset_is_subset
  find $subset($diff(%a as set(%'v2),%b as set(%'v2)) as set(%'v2),%c as set(%'v2)) as bool
  assume $subset(%a,%c) |-
  where toplevel 
  samegoal
    replace true as bool
  tags
    rewrite "fol simp"
    derived ""
    verbosity "6"

rule subset_of_union
  find $subset(%a as set(%'v1),$union(%b as set(%'v1),%c as set(%'v1)) as set(%'v1)) as bool
  assume $subset(%a,%b) |-
  where toplevel 
  samegoal
    replace true as bool
  tags
    rewrite "fol simp"
    derived ""
    verbosity "6"

rule prec_set
  find $prec(%a as set(%'x),%b as set(%'x)) as bool
  where freshVar %x, %a, %b
  samegoal
    replace $and($and($subset(%a as set(%'x),%b as set(%'x)) as bool,(\exists %x as %'x;$mem(%x as %'x,$diff(%b as set(%'x),%a as set(%'x)) as set(%'x)) as bool) as bool) as bool,finite(%b as set(%'x)) as bool) as bool
  tags
    rewrite "fol simp"
    verbosity "8"

rule union_empty_l
  find $union(emptyset as set(%'v2),%a as set(%'v2)) as set(%'v2)
  samegoal
    replace %a as set(%'v2)
  tags
    rewrite "concrete"
    derived ""
    verbosity "8"

rule union_empty_r
  find $union(%a as set(%'v2),emptyset as set(%'v2)) as set(%'v2)
  samegoal
    replace %a as set(%'v2)
  tags
    rewrite "concrete"
    derived ""
    verbosity "8"

rule in_union
  find $mem(%x as %'x,$union(%a as set(%'x),%b as set(%'x)) as set(%'x)) as bool
  samegoal
    replace $or($mem(%x as %'x,%a as set(%'x)) as bool,$mem(%x as %'x,%b as set(%'x)) as bool) as bool

rule intersect_empty_l
  find $intersect(emptyset as set(%'v2),%a as set(%'v2)) as set(%'v2)
  samegoal
    replace emptyset as set(%'v2)
  tags
    rewrite "concrete"
    derived ""
    verbosity "8"

rule intersect_empty_r
  find $intersect(%a as set(%'v2),emptyset as set(%'v2)) as set(%'v2)
  samegoal
    replace emptyset as set(%'v2)
  tags
    rewrite "concrete"
    derived ""
    verbosity "8"

rule in_intersect
  find $mem(%x as %'x,$intersect(%a as set(%'x),%b as set(%'x)) as set(%'x)) as bool
  samegoal
    replace $and($mem(%x as %'x,%a as set(%'x)) as bool,$mem(%x as %'x,%b as set(%'x)) as bool) as bool
  tags
    derived ""


function set('v3) a
function set('v3) b
function set('v3) c


problem
  $impl($not($subset($intersect(a as set('v3),b as set('v3)) as set('v3),c as set('v3)) as bool) as bool,$not($subset(a as set('v3),c as set('v3)) as bool) as bool) as bool
